﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.801
@EndOfDesignText@
#Region  Activity Attributes 

	#FullScreen: False
	#IncludeTitle: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Public SQLEC As SQL

	Dim timAppClose As Timer
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	'v0.1  (13/05/2020) - Initial development
	Private strVersion As String = "v0.1"
	Private lblVersion As Label
	
	Private pnlExpenseSummary As Panel
	Private lblExpenseSummary1 As Label
	Private lblExpenseSummary2 As Label
	
	Private strFromReceiptDate As String
	Private strToReceiptDate As String
	Private intTotalReceipts As Int
	Private dblTotalAmount As Double
	Private intTotalAmount As Int
	Private strTotalAmount As String
	
	Private strSQLQuery As String
	
	Private CSB As CSBuilder
	
	Private int0 As Int = 0
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	File.Copy(File.DirAssets, "ExpenseClaims.db", File.DirInternal, "ExpenseClaims.db")

	SQLEC.Initialize(File.DirInternal, "ExpenseClaims.db", False)
	
	timAppClose.Initialize("AppClose", 60000)

	Activity.LoadLayout("ECS00")
	
	lblVersion.Text = strVersion

End Sub

Sub Activity_Resume
	
	timAppClose.Enabled = True

	CalculateOutstandingExpenses
		
End Sub

Sub Activity_Pause (UserClosed As Boolean)

	If UserClosed Then
		SQLEC.Close
		ExitApplication
	End If

End Sub

'DATABASE CALLS
'==============

Sub CalculateOutstandingExpenses
	
	strSQLQuery = "Select COUNT() FROM Receipt "
	strSQLQuery = strSQLQuery & "WHERE ReceiptClaimID = " & int0
	intTotalReceipts = SQLEC.ExecQuerySingleResult(strSQLQuery)
	
	If intTotalReceipts = int0 Then
		pnlExpenseSummary.Visible = False
		Return
	Else
		pnlExpenseSummary.Visible = True
	End If

	strSQLQuery = "Select ReceiptDate FROM Receipt "
	strSQLQuery = strSQLQuery & "WHERE ReceiptClaimID = " & int0
	strSQLQuery = strSQLQuery & " ORDER BY ReceiptDate ASC"
	strFromReceiptDate = SQLEC.ExecQuerySingleResult(strSQLQuery)
	
	strSQLQuery = "Select ReceiptDate FROM Receipt "
	strSQLQuery = strSQLQuery & "WHERE ReceiptClaimID = " & int0
	strSQLQuery = strSQLQuery & " ORDER BY ReceiptDate DESC"
	strToReceiptDate = SQLEC.ExecQuerySingleResult(strSQLQuery)

	strSQLQuery = "Select TOTAL(ReceiptAmount) FROM Receipt "
	strSQLQuery = strSQLQuery & "WHERE ReceiptClaimID = " & int0
	dblTotalAmount = SQLEC.ExecQuerySingleResult(strSQLQuery)
	intTotalAmount = dblTotalAmount
	If dblTotalAmount = int0 Then
		strTotalAmount = "0.00"
	Else
		If dblTotalAmount = intTotalAmount Then
			strTotalAmount = dblTotalAmount & ".00"
		Else
			strTotalAmount = dblTotalAmount
		End If
	End If
	If strTotalAmount.CharAt(strTotalAmount.Length - 2) = "." Then
		strTotalAmount = strTotalAmount & "0"
	End If
	strTotalAmount = "£" & strTotalAmount
	
	CSB.Initialize.Append("From: ").Color(Colors.Yellow).Append(strFromReceiptDate.SubString2(4, 6))
	CSB.Append("/").Append(strFromReceiptDate.SubString2(2, 4)).Append("/")
	CSB.Append(strFromReceiptDate.SubString2(0, 2)).Pop.Append("        No: ")
	CSB.Color(Colors.Yellow).Append(intTotalReceipts).PopAll
	lblExpenseSummary1.text = CSB
	
	CSB.Initialize.Append("     To: ").Color(Colors.Yellow).Append(strToReceiptDate.SubString2(4, 6))
	CSB.Append("/").Append(strToReceiptDate.SubString2(2, 4)).Append("/")
	CSB.Append(strToReceiptDate.SubString2(0, 2)).Pop.Append("   Value: ")
	CSB.Color(Colors.Yellow).Append(strTotalAmount).PopAll
	lblExpenseSummary2.text = CSB

End Sub

'CLICK EVENTS
'============

Sub lblAddReceipt_Click
	
	timAppClose.Enabled = False

	StartActivity("ECS10")
	
End Sub

Sub lblUpdateReceipt_Click
	
	timAppClose.Enabled = False
	
	StartActivity("ECS20")

End Sub

Sub lblClaimExpenses_Click
	
	timAppClose.Enabled = False
	
'	StartActivity("ECS30")

End Sub

Sub lblReceiptEnquiry_Click
	
	timAppClose.Enabled = False
	
'	StartActivity("ECS40")

End Sub

Sub imgExit_Click
	
	SQLEC.Close

	ExitApplication

End Sub

Sub AppClose_Tick
	
	SQLEC.Close

	ExitApplication

End Sub
