﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.801
@EndOfDesignText@
#Region  Activity Attributes 

	#FullScreen: False
	#IncludeTitle: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Private frontCamera As Boolean = False

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Dim IME As IME
	Private CSB As CSBuilder

	'v0.1  (14/05/2020) - Initial development
	Private strVersion As String = "v0.1"
	Private lblVersion As Label

	Private camEx As CameraEXClass
	Private pnlPhoto As Panel
	Private pnlTapForPhoto As Panel
	Private lblTapForPhoto As Label
	Private bmpPhoto As Bitmap
	Private bolPhotoTaken As Boolean
	Dim InPhoto As InputStream
	Dim OutPhoto As OutputStream
	Dim Buffer() As Byte

	Private ECReceiptSet As ResultSet
	Private strReceiptID As String
	Private tmpReceiptID As String
	Private intID As Int
	
	Private lblReceiptDate As Label
	Private whlReceiptDate As CLSWheel
	Private strReceiptDate As String

	Private lblRetailerName As Label
	Private edtRetailerName As EditText
	
	Private lblAmount As Label
	Private edtAmount As EditText
	Private strAmount As String
	Private dblAmount As Double
	
	Private lblStoreCharge As Label
	Private strStoreName As String
	
	Private lblNotesLabel As Label
	Private lblNotes As Label
	Private edtNotes As EditText
	Private strNotes As String
	
	Private lblCancel As Label
	Private lblAdd As Label
	
	Private ECRetailerSet As ResultSet
	Private whlRetailer As CLSWheel
	Private intRetailerID As Int
	Private lstRetailerName(1) As List

	Private ECStoreSet As ResultSet
	Private whlStore As CLSWheel
	Private strStoreID As String
	Private lstStoreName(1) As List
	
	Private strSQLQuery As String

	Private strNothing As String = ""
	Private int0 As Int = 0
	Private int50 As Int = 50
	Private bolEventInProgress As Boolean
	
	Private lstSizes(1) As List
	Private intHeight As Int
	Private intWidth As Int
		
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	whlReceiptDate.Initialize(Me, Activity, "  Receipt Date  ", 3, Null, 34, 0, True)
	
	SelectRetailerList

	SelectStoreList

	DateTime.DateFormat = "dd/MM/yy"

	IME.Initialize("IME")

	bolEventInProgress = False
	
	Activity.LoadLayout("ECS10")
	
	lblVersion.Text = strVersion
	
	lblReceiptDate.Text = DateTime.Date(DateTime.Now)

	lblRetailerName.Text = "Morrisons"
	SelectRetailerID

	strStoreID = "Group"
	SelectStoreName
	lblStoreCharge.Text = strStoreName
	
	lblNotesLabel.Text = "Notes (" & (int50 - lblNotes.Text.Length) & ") :"
	
	IME.SetLengthFilter(edtRetailerName, 20)
	IME.SetLengthFilter(edtAmount, 7)
	IME.AddHandleActionEvent(edtAmount)
	IME.SetLengthFilter(edtNotes, 50)

End Sub

Sub Activity_Resume

	lblTapForPhoto.Text = ">> Tap For Photo <<"
	pnlTapForPhoto.Color = Colors.Yellow
	bolPhotoTaken = False

	InitializeCamera

End Sub

Sub Activity_Pause (UserClosed As Boolean)

	If camEx.IsInitialized Then
		camEx.Release
	End If

End Sub

Private Sub InitializeCamera
	
	Starter.rp.CheckAndRequest(Starter.rp.PERMISSION_CAMERA)
	
	Wait For Activity_PermissionResult (Permission As String, Result As Boolean)
	If Result Then
		camEx.Initialize(pnlPhoto, frontCamera, Me, "Camera1")
		frontCamera = camEx.Front
	Else
		ToastMessageShow("No permission!!!", True)
	End If
End Sub

Sub Camera1_Ready (Success As Boolean)
	
	If Success Then
'		camEx.GetSupportedPicturesSizes(lstSizes)
		camEx.SetPictureSize(720, 720)
'		intHeight = camEx.GetPictureSize.Height
'		intWidth = camEx.GetPictureSize.Width
'		Log("Height " & intHeight)
'		Log("Width " & intWidth)
		camEx.SetJpegQuality(10)
		camEx.SetContinuousAutoFocus
		camEx.CommitParameters
		camEx.StartPreview
	Else
		ToastMessageShow("Cannot open camera.", True)
	End If
	
End Sub

Sub Camera1_PictureTaken (Data() As Byte)
	
	InPhoto.InitializeFromBytesArray(Data, 0, Data.Length)
	
	bmpPhoto.Initialize2(InPhoto)
	
End Sub

'SELECT DATABASE CALLS
'=====================

Sub SelectReceiptIDMax
	
	strSQLQuery = "Select ReceiptID FROM Receipt WHERE ReceiptID LIKE '"	
	strSQLQuery = strSQLQuery & tmpReceiptID & "%' ORDER BY ReceiptID DESC"
	
	ECReceiptSet = ECS00.SQLEC.ExecQuery(strSQLQuery)
	Log (ECReceiptSet.RowCount)

	If ECReceiptSet.RowCount > int0 Then
		ECReceiptSet.NextRow
		tmpReceiptID = ECReceiptSet.GetString("ReceiptID")
	Else
		tmpReceiptID = tmpReceiptID & "000"
	End If
	Log ("tmpReceiptID " & tmpReceiptID)

End Sub

Sub SelectRetailerList

	lstRetailerName(0).Initialize
	
	strSQLQuery = "SELECT RetailerName FROM Retailer"
	
	ECRetailerSet = ECS00.SQLEC.ExecQuery(strSQLQuery)
	
	Do While ECRetailerSet.NextRow
		lstRetailerName(0).Add(ECRetailerSet.GetString("RetailerName"))
	Loop

	lstRetailerName(0).SortCaseInsensitive(True)
	
	whlRetailer.Initialize(Me, Activity, "  Retailer Name  ", 1, lstRetailerName, 34, 4, False)

End Sub

Sub SelectRetailerID
	
	strSQLQuery = "Select RetailerID FROM Retailer WHERE RetailerName = '"
	strSQLQuery = strSQLQuery & lblRetailerName.Text & "'"
	
	intRetailerID = ECS00.SQLEC.ExecQuerySingleResult(strSQLQuery)

End Sub

Sub SelectRetailerIDMax
	
	strSQLQuery = "Select MAX(RetailerID) FROM Retailer"
	
	intRetailerID = ECS00.SQLEC.ExecQuerySingleResult(strSQLQuery)

End Sub

Sub SelectRetailerName
		
	strSQLQuery = "Select RetailerName FROM Retailer WHERE RetailerName = '"
	strSQLQuery = strSQLQuery & lblRetailerName.Text & "'"
	
	ECRetailerSet = ECS00.SQLEC.ExecQuery(strSQLQuery)
	
End Sub

Sub SelectStoreList

	lstStoreName(0).Initialize
	
	strSQLQuery = "SELECT StoreName FROM Store"
	
	ECStoreSet = ECS00.SQLEC.ExecQuery(strSQLQuery)
	
	Do While ECStoreSet.NextRow
		lstStoreName(0).Add(ECStoreSet.GetString("StoreName"))
	Loop
	
	lstStoreName(0).SortCaseInsensitive(True)
	
	whlStore.Initialize(Me, Activity, "  Store Name  ", 1, lstStoreName, 34, 4, False)

End Sub

Sub SelectStoreID
	
	strSQLQuery = "Select StoreID FROM Store WHERE StoreName = '"
	strSQLQuery = strSQLQuery & lblStoreCharge.Text & "'"
	
	strStoreID = ECS00.SQLEC.ExecQuerySingleResult(strSQLQuery)

End Sub

Sub SelectStoreName
	
	strSQLQuery = "Select StoreName FROM Store WHERE StoreID = '"
	strSQLQuery = strSQLQuery & strStoreID & "'"
	
	strStoreName = ECS00.SQLEC.ExecQuerySingleResult(strSQLQuery)

End Sub

'INSERT DATABASE CALLS
'=====================

Sub InsertReceiptRecord

	strSQLQuery = "INSERT INTO Receipt VALUES "
	strSQLQuery = strSQLQuery & "(?, ?, ?, ?, ?, ?, ?, ?, ?)"

	ECS00.SQLEC.ExecNonQuery2(strSQLQuery, _
		Array As Object(strReceiptID, strReceiptDate, intRetailerID, dblAmount, strStoreID, _
			lblNotes.Text, OutPhoto.ToBytesArray, int0, int0))
	'						lblNotes.Text, Buffer, int0, int0))

End Sub

Sub InsertRetailerRecord

	intRetailerID = intRetailerID + 1
	
	strSQLQuery = "INSERT INTO Retailer VALUES (?, ?)"
	
	ECS00.SQLEC.ExecNonQuery2(strSQLQuery, _
		Array As Object(intRetailerID, lblRetailerName.Text))

End Sub

'CLICK EVENTS
'============

Sub lblTapForPhoto_Click

	If bolEventInProgress = True Then
		Return
	End If

	If lblTapForPhoto.Text = ">> Tap For Photo <<" Then
		camEx.FocusAndTakePicture
		lblTapForPhoto.Text = ">> Tap To Retake <<"
		pnlTapForPhoto.Color = Colors.Red
		bolPhotoTaken = True
	Else
		lblTapForPhoto.Text = ">> Tap For Photo <<"
		pnlTapForPhoto.Color = Colors.Yellow
		bolPhotoTaken = False
		camEx.StartPreview 'restart preview
	End If
	
End Sub

Sub lblReceiptDate_Click

	If bolEventInProgress = True Then
		Return
	End If

	bolEventInProgress = True
	
	whlReceiptDate.Show2("lblReceiptDate", lblReceiptDate.Text)
	
End Sub

Sub lblRetailerName_Click

	If bolEventInProgress = True Then
		Return
	End If
	
	bolEventInProgress = True
	
	whlRetailer.Show2("lblRetailerName", lblRetailerName.Text)
	
End Sub

Sub lblAmount_Click

	If bolEventInProgress = True Then
		Return
	End If

	bolEventInProgress = True
	
	lblAmount.Visible = False
	lblAmount.Enabled = False
	
	edtAmount.Text = lblAmount.Text
	edtAmount.Visible = True
	edtAmount.Enabled = True
	
	edtAmount.SelectionStart = edtAmount.Text.Length
	IME.ShowKeyboard(edtAmount)

End Sub

Sub lblStoreCharge_Click

	If bolEventInProgress = True Then
		Return
	End If
	
	bolEventInProgress = True
	
	whlStore.Show2("lblStoreCharge", lblStoreCharge.Text)

End Sub

Sub lblNotes_Click

	If bolEventInProgress = True Then
		Return
	End If

	bolEventInProgress = True

	lblNotes.Visible = False
	lblNotes.Enabled = False
	
	edtNotes.Text = lblNotes.Text
	edtNotes.Visible = True
	edtNotes.Enabled = True

	edtNotes.SelectionStart = edtNotes.Text.Length
	IME.ShowKeyboard(edtNotes)

End Sub

Sub lblCancel_Click
	
	Activity.Finish

End Sub

Sub lblAdd_Click

	If bolPhotoTaken = False Then
		CSB.Initialize.Bold.Color(Colors.Red).Size(30).Append("  Photo Not Taken  ").PopAll
		ToastMessageShow(CSB, True)
		Return
	End If
	
	tmpReceiptID = lblReceiptDate.Text.SubString2(6, 8) & lblReceiptDate.Text.SubString2(3, 5)
	
	SelectReceiptIDMax
		
	intID = tmpReceiptID.SubString2(4,7)
	Log (intID)
	intID = intID + 1
	If intID < 10 Then
		strReceiptID = tmpReceiptID.SubString2(0, 4) & "00" & intID
	Else If intID < 100 Then
		strReceiptID = tmpReceiptID.SubString2(0, 4) & "0" & intID
	Else
		strReceiptID = tmpReceiptID.SubString2(0, 4) & intID
	End If
	Log ("strReceiptID " & strReceiptID)
		
	strReceiptDate = lblReceiptDate.Text.SubString2(6, 8) & lblReceiptDate.Text.SubString2(3, 5)
	strReceiptDate = strReceiptDate & lblReceiptDate.Text.SubString2(0, 2)
	Log ("strReceiptDate " & strReceiptDate)
	
	Log ("intRetailerID " & intRetailerID)
	
	dblAmount = lblAmount.Text
	Log ("dblAmount " & dblAmount)
	
	Log ("strStoreID " & strStoreID)
	
	Log ("lblNotes.text " & lblNotes.Text)
	
'	OutPhoto.InitializeToBytesArray(0)
'	File.Copy2(InPhoto, OutPhoto)
'	Buffer = OutPhoto.ToBytesArray
	
	OutPhoto.InitializeToBytesArray(0)
	bmpPhoto.WriteToStream(OutPhoto, 10, "JPEG")
	OutPhoto.Close
	
	InsertReceiptRecord
	
	CSB.Initialize.Size(20).Append("Receipt  ")
	CSB.Bold.Color(Colors.Red).Size(30).Append(intID).Pop.Pop.Pop
	CSB.Append("  Added").PopAll
	
	ToastMessageShow(CSB, True)
	
	Activity.Finish

End Sub

'LONG CLICK EVENTS
'=================

Sub lblRetailerLabel_LongClick

	If bolEventInProgress = True Then
		Return
	End If

	bolEventInProgress = True

	lblRetailerName.Visible = False
	lblRetailerName.Enabled = False
	
	edtRetailerName.Text = strNothing
	edtRetailerName.Visible = True
	edtRetailerName.Enabled = True
	
	IME.ShowKeyboard(edtRetailerName)

End Sub

'ENTER PRESSED EVENTS
'====================

Sub edtRetailerName_EnterPressed
	
	IME.HideKeyboard

	edtRetailerName.Enabled = False
	edtRetailerName.Visible = False
	If edtRetailerName.Text <> lblRetailerName.Text _
	 And edtRetailerName.Text.Length <> 0 Then
		lblRetailerName.Text = edtRetailerName.Text
		SelectRetailerName
		If ECRetailerSet.RowCount = int0 Then
			SelectRetailerIDMax
			InsertRetailerRecord
			SelectRetailerList
		End If
	End If
	
	lblRetailerName.Enabled = True
	lblRetailerName.Visible = True

	bolEventInProgress = False

End Sub

' This routine handles edtAmount_EnterPressed
Sub IME_HandleAction As Boolean
	
	If edtAmount.TextColor = Colors.Red Then
		Return True
	End If

	edtAmount.Enabled = False
	edtAmount.Visible = False
	
	lblAmount.TextColor = edtAmount.TextColor
	lblAmount.Text = edtAmount.Text
	lblAmount.Enabled = True
	lblAmount.Visible = True

	bolEventInProgress = False

	lblAdd.Enabled = True
	
	Return False
		
End Sub

Sub edtNotes_EnterPressed
	
	IME.HideKeyboard

	edtNotes.Enabled = False
	edtNotes.Visible = False
	
	lblNotes.Text = edtNotes.Text
	lblNotes.Enabled = True
	lblNotes.Visible = True

	bolEventInProgress = False

End Sub

'CLOSED EVENTS
'=============

Sub lblReceiptDate_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		lblReceiptDate.Text = Selection
	End If

	bolEventInProgress = False

End Sub

Sub lblRetailerName_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		lblRetailerName.Text = Selection
		SelectRetailerID
	End If

	bolEventInProgress = False

End Sub

Sub lblStoreCharge_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		lblStoreCharge.Text = Selection
		SelectStoreID
	End If

	bolEventInProgress = False

End Sub

'TEXT CHANGED EVENTS
'===================

Sub edtAmount_TextChanged (Old As String, New As String)
	
	strAmount = New
	
	If strAmount.Length < 4 Then
		edtAmount.TextColor = Colors.Red
		Return
	End If

	If strAmount.StartsWith("-") _
	 And strAmount.CharAt(1) = "." Then
		edtAmount.TextColor = Colors.Red
		Return
	End If
	
	If strAmount.CharAt(strAmount.Length - 3) <> "." Then
		edtAmount.TextColor = Colors.Red
		Return
	End If

	If strAmount.StartsWith("-") Then
		edtAmount.TextColor = Colors.Green
	Else
		edtAmount.TextColor = Colors.Yellow
	End If
	
End Sub

Sub edtNotes_TextChanged (Old As String, New As String)

	strNotes = New.Trim
	lblNotesLabel.Text = "Notes (" & (int50 - strNotes.Length) & ") :"
	
End Sub