﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.801
@EndOfDesignText@
#Region  Activity Attributes 

	#FullScreen: False
	#IncludeTitle: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Private XUI As XUI

	Type ItemValue (rtnReceiptID As String)
	
	Public strSelectedReceiptID As String
	Public bolDeletedReceipt As Boolean
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
		
	'v0.1  (17/05/2020) - Initial development
	Private strVersion As String = "v0.1"
	Private lblVersion As Label

	Private clvPanel As CustomListView
	
	Private intSelectedIndex As Int

	Private lblReceiptID As Label
	Private lblReceiptDate As Label
	Private lblRetailerName As Label
	Private lblReceiptAmount As Label
	Private lblStoreChargeName As Label
	Private lblReceiptClaimID As Label
	Private lblReceiptNotes As Label
	Private pnlPhoto as Panel
	Private imgPhoto As ImageView
	
	Private ECReceiptSet As ResultSet

	Private outReceiptID As String
	Private outReceiptDate As String
	Private outRetailerName As String
	Private outReceiptAmount As String
	Private outStoreChargeName As String
	Private outReceiptClaimID As String
	Private outReceiptNotes As String
	Private outReceiptPhoto As InputStream
	
	Private intReceiptRetailerID As Int
	Private strReceiptDate As String
	Private intReceiptAmount As Int
	Private dblReceiptAmount As Double
	Private strStoreChargeID As String
	
	Dim bytes() As Byte
	Dim bmp As Bitmap
	
	Private lblBack As Label
		
	Private strSQLQuery As String
	
	Private strNothing As String = ""
	Private int0 As Int = 0
		
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	Activity.LoadLayout("ECS20")
	
	lblVersion.Text = strVersion
	
	intSelectedIndex = int0
	
End Sub

Sub Activity_Resume

	clvPanel.Clear

	SelectReceiptList

	If bolDeletedReceipt = True Then
		If intSelectedIndex > int0 Then
			intSelectedIndex = intSelectedIndex - 1
		End If
	End If
	clvPanel.JumpToItem(intSelectedIndex)
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)

	Log ("index first " & clvPanel.FirstVisibleIndex)
	Log ("index last  " & clvPanel.LastVisibleIndex)

	intSelectedIndex = clvPanel.FirstVisibleIndex
	Log (" value " & clvPanel.GetValue(intSelectedIndex))

End Sub

Sub CreateItem(ReceiptID As String, ReceiptDate As String, RetailerName As String, _
							 ReceiptAmount As String, StoreChargeName As String, ReceiptClaimID As String, _
							 ReceiptNotes As String, ReceiptPhoto As InputStream) As B4XView

	Dim p As B4XView = XUI.CreatePanel("")
	
	p.SetLayoutAnimated(0, 0, 0, 100%x, 153dip)
	p.LoadLayout("ECS20clv")
	
	lblReceiptID.Text = ReceiptID
	lblReceiptDate.Text = ReceiptDate
	lblRetailerName.Text = RetailerName
	SetEllipsize(lblRetailerName, "END")
	lblReceiptAmount.Text = ReceiptAmount
	If dblReceiptAmount < int0 Then
		lblReceiptAmount.TextColor = Colors.Green
	Else
		lblReceiptAmount.TextColor = Colors.Yellow
	End If
	lblStoreChargeName.Text = StoreChargeName
	SetEllipsize(lblStoreChargeName, "END")
	lblReceiptClaimID.Text = ReceiptClaimID
	lblReceiptNotes.Text = ReceiptNotes
	SetEllipsize(lblReceiptNotes, "END")
	lblReceiptNotes.BringToFront
'	imgPhoto.SetBackgroundImage(bmp.Rotate(90))
	pnlPhoto.SetBackgroundImage(bmp.Rotate(90))
	Return p
	
End Sub

Sub SetEllipsize(TextView As Label, Mode As String)
	
	Dim r As Reflector
	r.Target = TextView
	r.RunMethod2("setLines", 1, "java.lang.int")
	r.RunMethod2("setHorizontallyScrolling", True, "java.lang.boolean")
	r.RunMethod2("setEllipsize", Mode, "android.text.TextUtils$TruncateAt")
'	r.RunMethod2("setSelected", True, "java.lang.boolean")
	
End Sub

'SELECT DATABASE CALLS
'=====================

Sub SelectReceiptList

	strSQLQuery = "Select * FROM Receipt ORDER BY ReceiptID DESC"
	
	ECReceiptSet = ECS00.SQLEC.ExecQuery(strSQLQuery)
	
	clvPanel.sv.Visible = False
	
	Log ("Start " & DateTime.Now)
	ProgressDialogShow2("Updating All Entries...",False)
	Do While ECReceiptSet.NextRow
		outReceiptID = ECReceiptSet.GetString("ReceiptID")
		Log("ReceiptID " & outReceiptID)
		strReceiptDate = ECReceiptSet.GetString("ReceiptDate")
		outReceiptDate = strReceiptDate.SubString2(4, 6) & "/" & strReceiptDate.SubString2(2, 4)
		outReceiptDate = outReceiptDate & "/" & strReceiptDate.SubString2(0, 2)
		intReceiptRetailerID = ECReceiptSet.GetInt("ReceiptRetailerID")
		SelectRetailerName
		dblReceiptAmount = ECReceiptSet.GetDouble("ReceiptAmount")
		intReceiptAmount = dblReceiptAmount
		If dblReceiptAmount = intReceiptAmount Then
			outReceiptAmount = dblReceiptAmount & ".00"
		Else
			outReceiptAmount = dblReceiptAmount
		End If
		If outReceiptAmount.CharAt(outReceiptAmount.Length - 2) = "." Then
			outReceiptAmount = outReceiptAmount & "0"
		End If
		strStoreChargeID = ECReceiptSet.GetString("ReceiptChargeStoreID")
		SelectStoreName
		outReceiptNotes = ECReceiptSet.GetString("ReceiptNotes")
		bytes = ECReceiptSet.GetBlob("ReceiptPhoto")
		'==========
'		InPhoto.InitializeFromBytesArray(bytes, 0, bytes.Length)
'		bmpPhoto.Initialize2(InPhoto)
		'===========
		outReceiptPhoto.InitializeFromBytesArray(bytes, 0, bytes.Length)
		bmp.Initialize2(outReceiptPhoto)
		outReceiptClaimID = ECReceiptSet.GetInt("ReceiptClaimID")
		If outReceiptClaimID = "0" Then
			outReceiptClaimID = strNothing
		Else
			outReceiptClaimID = outReceiptClaimID & "." & ECReceiptSet.GetInt("ReceiptClaimPart")
		End If
		clvPanel.Add(CreateItem(outReceiptID, outReceiptDate, outRetailerName, outReceiptAmount, _
														outStoreChargeName, outReceiptClaimID, outReceiptNotes, _
														outReceiptPhoto), outReceiptID)
	Loop
	ProgressDialogHide
	Log ("End " & DateTime.Now)
	
	clvPanel.sv.Visible = True
	
End Sub

Sub SelectRetailerName
		
	strSQLQuery = "Select RetailerName FROM Retailer WHERE RetailerID = ?"
	
	outRetailerName = ECS00.SQLEC.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(intReceiptRetailerID))
	
End Sub

Sub SelectStoreName
	
	strSQLQuery = "Select StoreName FROM Store WHERE StoreID = ?"
	
	outStoreChargeName = ECS00.SQLEC.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(strStoreChargeID))
		
End Sub

'CLICK EVENTS
'============

Sub clvPanel_ItemClick (Index As Int, Value As Object)
	
	intSelectedIndex = Index
	strSelectedReceiptID = Value
	bolDeletedReceipt = False
	
	StartActivity(ECS21)
	
End Sub

Sub lblBack_Click
	
	Activity.Finish

End Sub


