﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.801
@EndOfDesignText@
#Region  Activity Attributes 

	#FullScreen: False
	#IncludeTitle: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Private frontCamera As Boolean = False

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Dim IME As IME
	Private CSB As CSBuilder

	'v0.1  (20/05/2020) - Initial development
	Private strVersion As String = "v0.1"
	Private lblVersion As Label

	Private camEx As CameraEXClass
	Private pnlPhoto As Panel
	Private pnlTapForPhoto As Panel
	Private lblTapForPhoto As Label
	Dim bytes() As Byte
	Dim Buffer() As Byte
	Private bmpPhoto As Bitmap
	Dim InPhoto As InputStream
	Dim OutPhoto As OutputStream
	Private bolPhotoTaken As Boolean

	Private ECReceiptSet As ResultSet
	Private strReceiptDate As String
	Private intReceiptRetailerID As Int
	Private dblReceiptAmount As Double
	Private intReceiptAmount As Int
	Private strChargeStoreID As String
	Private intReceiptClaimID As Int
	Private intReceiptClaimPart As Int
	
	Private oldReceiptDate As String
	Private oldReceiptRetailerName As String
	Private oldReceiptAmount As String
	Private oldReceiptStoreName As String
	Private oldReceiptNotes As String
	Private oldReceiptClaim As String
	
	Private lblReceiptDate As Label
	Private whlReceiptDate As CLSWheel

	Private lblRetailerName As Label
	Private edtRetailerName As EditText
	
	Private lblAmount As Label
	Private edtAmount As EditText
	Private strAmount As String
	
	Private lblStoreCharge As Label
	
	Private lblNotesLabel As Label
	Private lblNotes As Label
	Private edtNotes As EditText
	Private strNotes As String
	
	Private lblDelete As Label
	Private lblBack As Label

	Private ECRetailerSet As ResultSet
	Private whlRetailer As CLSWheel
'	Private intRetailerID As Int
	Private lstRetailerName(1) As List

	Private ECStoreSet As ResultSet
	Private whlStore As CLSWheel
	Private strStoreID As String
	Private lstStoreName(1) As List
	
	Private strSQLQuery As String
	
	Dim bmp As Bitmap

	Private strNothing As String = ""
	Private int0 As Int = 0
	Private int50 As Int = 50
	Private bolEventInProgress As Boolean

	Private intUpdateType As Int
	Private strUpdateField As String
	Private strUpdateValue As String
	Private intUpdateValue As Int
	Private dblUpdateValue As Double
	
	Dim ctMessage As CustomToast
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	whlReceiptDate.Initialize(Me, Activity, "  Receipt Date  ", 3, Null, 34, 0, True)
	
	SelectRetailerList

	SelectStoreList

	DateTime.DateFormat = "dd/MM/yy"

	IME.Initialize("IME")

	ctMessage.Initialize

	bolEventInProgress = False
	
	Activity.LoadLayout("ECS21")
	
	lblVersion.Text = strVersion
	
	SelectReceiptRecord
	
	IME.SetLengthFilter(edtRetailerName, 20)
	IME.SetLengthFilter(edtAmount, 7)
	IME.AddHandleActionEvent(edtAmount)
	IME.SetLengthFilter(edtNotes, 50)
	
	CSB.Initialize.Size(20).Bold.Color(Colors.Red).Append("This is a 1750 test").PopAll
	ctMessage.Show(CSB,1000,Gravity.TOP,0,1750)
End Sub

Sub Activity_Resume

	lblTapForPhoto.Text = ">> Tap To Retake <<"
	pnlTapForPhoto.Color = Colors.Red
	bolPhotoTaken = False

End Sub

Sub Activity_Pause (UserClosed As Boolean)

	If camEx.IsInitialized Then
		camEx.Release
	End If

End Sub

Private Sub InitializeCamera
	
	Starter.rp.CheckAndRequest(Starter.rp.PERMISSION_CAMERA)
	
	Wait For Activity_PermissionResult (Permission As String, Result As Boolean)
	If Result Then
		camEx.Initialize(pnlPhoto, frontCamera, Me, "Camera1")
		frontCamera = camEx.Front
	Else
		ToastMessageShow("No permission!!!", True)
	End If
End Sub

Sub Camera1_Ready (Success As Boolean)
	
	If Success Then
		camEx.SetPictureSize(720, 720)
		camEx.SetJpegQuality(10)
		camEx.SetContinuousAutoFocus
		camEx.CommitParameters
		camEx.StartPreview
	Else
		ToastMessageShow("Cannot open camera.", True)
	End If
	
End Sub

Sub Camera1_PictureTaken (Data() As Byte)
	
	InPhoto.InitializeFromBytesArray(Data, 0, Data.Length)
	
	bmpPhoto.Initialize2(InPhoto)
	
End Sub

'SELECT DATABASE CALLS
'=====================

Sub SelectReceiptIDMax
	
'	strSQLQuery = "Select ReceiptID FROM Receipt WHERE ReceiptID LIKE '"
'	strSQLQuery = strSQLQuery & tmpReceiptID & "%' ORDER BY ReceiptID DESC"
'	
'	ECReceiptSet = ECS00.SQLEC.ExecQuery(strSQLQuery)
'	Log (ECReceiptSet.RowCount)
'
'	If ECReceiptSet.RowCount > int0 Then
'		ECReceiptSet.NextRow
'		tmpReceiptID = ECReceiptSet.GetString("ReceiptID")
'	Else
'		tmpReceiptID = tmpReceiptID & "000"
'	End If
'	Log ("tmpReceiptID " & tmpReceiptID)

End Sub

Sub SelectReceiptRecord
	
	strSQLQuery = "Select * FROM Receipt WHERE ReceiptID = ?"
	
	ECReceiptSet = ECS00.SQLEC.ExecQuery2(strSQLQuery, _
		Array As String(ECS20.strSelectedReceiptID))

	ECReceiptSet.NextRow
	
	strReceiptDate = ECReceiptSet.GetString("ReceiptDate")
	lblReceiptDate.Text = strReceiptDate.SubString2(4, 6) & "/" & strReceiptDate.SubString2(2, 4)
	lblReceiptDate.Text = lblReceiptDate.Text & "/" & strReceiptDate.SubString2(0, 2)
	intReceiptRetailerID = ECReceiptSet.GetInt("ReceiptRetailerID")
	SelectRetailerName
	dblReceiptAmount = ECReceiptSet.GetDouble("ReceiptAmount")
	intReceiptAmount = dblReceiptAmount
	If dblReceiptAmount = intReceiptAmount Then
		lblAmount.Text = dblReceiptAmount & ".00"
	Else
		lblAmount.Text = dblReceiptAmount
	End If
	If lblAmount.Text.CharAt(lblAmount.Text.Length - 2) = "." Then
		lblAmount.Text = lblAmount.Text & "0"
	End If
	If dblReceiptAmount < int0 Then
		lblAmount.TextColor = Colors.Green
	Else
		lblAmount.TextColor = Colors.Yellow
	End If
	strChargeStoreID = ECReceiptSet.GetString("ReceiptChargeStoreID")
	SelectStoreName
	lblNotes.Text = ECReceiptSet.GetString("ReceiptNotes")
	lblNotesLabel.Text = "Notes (" & (int50 - lblNotes.Text.Length) & ") :"
	bytes = ECReceiptSet.GetBlob("ReceiptPhoto")
	InPhoto.InitializeFromBytesArray(bytes, 0, bytes.Length)
	bmpPhoto.Initialize2(InPhoto)
	pnlPhoto.SetBackgroundImage(bmpPhoto.Rotate(90))
	intReceiptClaimID = ECReceiptSet.GetInt("ReceiptClaimID")
	intReceiptClaimPart = ECReceiptSet.GetInt("ReceiptClaimPart")

End Sub

Sub SelectRetailerList

	lstRetailerName(0).Initialize
	
	strSQLQuery = "SELECT RetailerName FROM Retailer"
	
	ECRetailerSet = ECS00.SQLEC.ExecQuery(strSQLQuery)
	
	Do While ECRetailerSet.NextRow
		lstRetailerName(0).Add(ECRetailerSet.GetString("RetailerName"))
	Loop

	lstRetailerName(0).SortCaseInsensitive(True)
	
	whlRetailer.Initialize(Me, Activity, "  Retailer Name  ", 1, lstRetailerName, 34, 4, False)

End Sub

Sub SelectRetailerID
	
	strSQLQuery = "Select RetailerID FROM Retailer WHERE RetailerName = ?"
	
	intReceiptRetailerID = ECS00.SQLEC.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(lblRetailerName.Text))
		
End Sub

Sub SelectRetailerIDMax
	
	strSQLQuery = "Select MAX(RetailerID) FROM Retailer"
	
	intReceiptRetailerID = ECS00.SQLEC.ExecQuerySingleResult(strSQLQuery)

End Sub

Sub SelectRetailerName
		
	strSQLQuery = "Select RetailerName FROM Retailer WHERE RetailerID = ?"
	
	lblRetailerName.Text = ECS00.SQLEC.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(intReceiptRetailerID))
	
End Sub

Sub SelectStoreList

	lstStoreName(0).Initialize
	
	strSQLQuery = "SELECT StoreName FROM Store"
	
	ECStoreSet = ECS00.SQLEC.ExecQuery(strSQLQuery)
	
	Do While ECStoreSet.NextRow
		lstStoreName(0).Add(ECStoreSet.GetString("StoreName"))
	Loop
	
	lstStoreName(0).SortCaseInsensitive(True)
	
	whlStore.Initialize(Me, Activity, "  Store Name  ", 1, lstStoreName, 34, 4, False)

End Sub

Sub SelectStoreID
	
	strSQLQuery = "Select StoreID FROM Store WHERE StoreName = ?"
	
	strStoreID = ECS00.SQLEC.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(lblStoreCharge.Text))

End Sub

Sub SelectStoreName
	
	strSQLQuery = "Select StoreName FROM Store WHERE StoreID = ?"
	
	lblStoreCharge.Text = ECS00.SQLEC.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(strChargeStoreID))

End Sub

'INSERT DATABASE CALLS
'=====================

Sub InsertReceiptRecord

	Private strID = ECS20.bolDeletedReceipt & "1"
	strSQLQuery = "INSERT INTO Receipt VALUES "
	strSQLQuery = strSQLQuery & "(?, ?, ?, ?, ?, ?, ?, ?, ?)"

	ECS00.SQLEC.ExecNonQuery2(strSQLQuery, _
		Array As Object(strID, strReceiptDate, intReceiptRetailerID, dblReceiptAmount, strChargeStoreID, _
						lblNotes.Text, OutPhoto.ToBytesArray, int0, int0))

End Sub

Sub InsertRetailerRecord

	intReceiptRetailerID = intReceiptRetailerID + 1
	
	strSQLQuery = "INSERT INTO Retailer VALUES (?, ?)"
	
	ECS00.SQLEC.ExecNonQuery2(strSQLQuery, _
		Array As Object(intReceiptRetailerID, lblRetailerName.Text))

End Sub

'UPDATE DATABASE CALLS
'=====================

Sub UpdateReceiptRecord
	
	strSQLQuery = "UPDATE Receipt Set " & strUpdateField & " = ? WHERE ReceiptID = ?"

	Select intUpdateType
		Case 1 ' Strings
			ECS00.SQLEC.ExecNonQuery2(strSQLQuery, _
				Array As Object(strUpdateValue, ECS20.strSelectedReceiptID))
		Case 2 ' Integers
			ECS00.SQLEC.ExecNonQuery2(strSQLQuery, _
				Array As Object(intUpdateValue, ECS20.strSelectedReceiptID))
		Case 3 ' Double
			ECS00.SQLEC.ExecNonQuery2(strSQLQuery, _
				Array As Object(dblUpdateValue, ECS20.strSelectedReceiptID))
		Case 4 ' Blob
			Log ("Updating Photo")
			ECS00.SQLEC.ExecNonQuery2(strSQLQuery, _
				Array As Object(OutPhoto.ToBytesArray, ECS20.strSelectedReceiptID))
'				Array As Object(Buffer, ECS20.strSelectedReceiptID))
	End Select

End Sub

'CLICK EVENTS
'============

Sub lblTapForPhoto_Click

	If bolEventInProgress = True Then
		Return
	End If
	'==============
'	File.Copy2(InputStream1, OutputStream1)
'	Dim Buffer() As Byte 'declares an empty array
'	Buffer = OutputStream1.ToBytesArray
'================
	If lblTapForPhoto.Text = ">> Tap For Photo <<" Then
		camEx.FocusAndTakePicture
		bolPhotoTaken = True
		intUpdateType = 4
		strUpdateField = "ReceiptPhoto"
		OutPhoto.InitializeToBytesArray(0)
'		File.Copy2(InPhoto, OutPhoto)
'		Buffer = OutPhoto.ToBytesArray
		bmpPhoto.WriteToStream(OutPhoto, 10, "JPEG")
		OutPhoto.Close
'		InsertReceiptRecord
		UpdateReceiptRecord
		CSB.Initialize.Size(20).Bold.Color(Colors.Red).Append("Photo Updated").PopAll
		ToastMessageShow(CSB, True)
		lblTapForPhoto.Text = ">> Tap To Retake <<"
		pnlTapForPhoto.Color = Colors.Red
	Else
		lblTapForPhoto.Text = ">> Tap For Photo <<"
		pnlTapForPhoto.Color = Colors.Yellow
		If bolPhotoTaken = False Then
			Log ("Camera initialized = " & camEx.IsInitialized)
			InitializeCamera
		Else
			camEx.StartPreview 'restart preview
		End If
	End If
	
End Sub

Sub lblReceiptDate_Click

	If bolEventInProgress = True Then
		Return
	End If

	bolEventInProgress = True

	whlReceiptDate.Show2("lblReceiptDate", lblReceiptDate.Text)
	
End Sub

Sub lblRetailerName_Click

	If bolEventInProgress = True Then
		Return
	End If
	
	bolEventInProgress = True
	
	whlRetailer.Show2("lblRetailerName", lblRetailerName.Text)
	
End Sub

Sub lblAmount_Click

	If bolEventInProgress = True Then
		Return
	End If

	bolEventInProgress = True
	
	lblAmount.Visible = False
	lblAmount.Enabled = False
	
	edtAmount.Text = lblAmount.Text
	edtAmount.Visible = True
	edtAmount.Enabled = True
	
	edtAmount.SelectionStart = edtAmount.Text.Length
	IME.ShowKeyboard(edtAmount)

End Sub

Sub lblStoreCharge_Click

	If bolEventInProgress = True Then
		Return
	End If
	
	bolEventInProgress = True
	
	whlStore.Show2("lblStoreCharge", lblStoreCharge.Text)

End Sub

Sub lblNotes_Click

	If bolEventInProgress = True Then
		Return
	End If

	bolEventInProgress = True

	lblNotes.Visible = False
	lblNotes.Enabled = False
	
	edtNotes.Text = lblNotes.Text
	edtNotes.Visible = True
	edtNotes.Enabled = True

	edtNotes.SelectionStart = edtNotes.Text.Length
	IME.ShowKeyboard(edtNotes)

End Sub

Sub lblDelete_Click

	Activity.Finish

End Sub

Sub lblUpdate_Click

'	tmpReceiptID = lblReceiptDate.Text.SubString2(6, 8) & lblReceiptDate.Text.SubString2(3, 5)
'	
'	SelectReceiptIDMax
'		
'	intID = tmpReceiptID.SubString2(4,7)
'	Log (intID)
'	intID = intID + 1
'	If intID < 10 Then
'		strReceiptID = tmpReceiptID.SubString2(0, 4) & "00" & intID
'	Else If intID < 100 Then
'		strReceiptID = tmpReceiptID.SubString2(0, 4) & "0" & intID
'	Else
'		strReceiptID = tmpReceiptID.SubString2(0, 4) & intID
'	End If
'	Log ("strReceiptID " & strReceiptID)
'		
'	strReceiptDate = lblReceiptDate.Text.SubString2(6, 8) & lblReceiptDate.Text.SubString2(3, 5)
'	strReceiptDate = strReceiptDate & lblReceiptDate.Text.SubString2(0, 2)
'	Log ("strReceiptDate " & strReceiptDate)
'	
'	Log ("intRetailerID " & intRetailerID)
'	
'	dblAmount = lblAmount.Text
'	Log ("dblAmount " & dblAmount)
'	
'	Log ("strStoreID " & strStoreID)
'	
'	Log ("lblNotes.text " & lblNotes.Text)
'
'	OutPhoto.InitializeToBytesArray(0)
'	bmpPhoto.WriteToStream(OutPhoto, 10, "JPEG")
'	OutPhoto.Close
'	
'	InsertReceiptRecord
'	
'	CSB.Initialize.Size(20).Append("Receipt  ")
'	CSB.Bold.Color(Colors.Red).Size(30).Append(intID).Pop.Pop.Pop
'	CSB.Append("  Added").PopAll
'	
'	ToastMessageShow(CSB, True)
	
	Activity.Finish

End Sub

Sub lblBack_Click
	
	Activity.Finish

End Sub

'LONG CLICK EVENTS
'=================

Sub lblRetailerLabel_LongClick

	If bolEventInProgress = True Then
		Return
	End If

	bolEventInProgress = True

	lblRetailerName.Visible = False
	lblRetailerName.Enabled = False
	
	edtRetailerName.Text = strNothing
	edtRetailerName.Visible = True
	edtRetailerName.Enabled = True
	
	IME.ShowKeyboard(edtRetailerName)

End Sub

'ENTER PRESSED EVENTS
'====================

Sub edtRetailerName_EnterPressed
	
	IME.HideKeyboard

	edtRetailerName.Enabled = False
	edtRetailerName.Visible = False
	If edtRetailerName.Text <> lblRetailerName.Text _
	 And edtRetailerName.Text.Length <> 0 Then
		lblRetailerName.Text = edtRetailerName.Text
		SelectRetailerName
		If ECRetailerSet.RowCount = int0 Then
			SelectRetailerIDMax
			InsertRetailerRecord
			SelectRetailerList
		End If
	End If
	
	lblRetailerName.Enabled = True
	lblRetailerName.Visible = True

	bolEventInProgress = False

End Sub

' This routine handles edtAmount_EnterPressed
Sub IME_HandleAction As Boolean
	
	If edtAmount.TextColor = Colors.Red Then
		Return True
	End If

	oldReceiptAmount = lblAmount.Text
	
	edtAmount.Enabled = False
	edtAmount.Visible = False
	
	lblAmount.TextColor = edtAmount.TextColor
	lblAmount.Text = edtAmount.Text
	lblAmount.Enabled = True
	lblAmount.Visible = True

	If oldReceiptAmount <> lblAmount.Text Then
		intUpdateType = 3
		strUpdateField = "ReceiptAmount"
		dblUpdateValue = lblAmount.Text
		UpdateReceiptRecord
		CSB.Initialize.Size(20).Bold.Color(Colors.Red).Append("Amount Updated").PopAll
		ToastMessageShow(CSB, True)
	End If

	bolEventInProgress = False

	Return False
		
End Sub

Sub edtNotes_EnterPressed
	
	IME.HideKeyboard

	oldReceiptNotes = lblNotes.Text

	edtNotes.Enabled = False
	edtNotes.Visible = False
	
	lblNotes.Text = edtNotes.Text
	lblNotes.Enabled = True
	lblNotes.Visible = True
	
	If oldReceiptNotes <> lblNotes.Text Then
		intUpdateType = 1
		strUpdateField = "ReceiptNotes"
		strUpdateValue = lblNotes.Text
		UpdateReceiptRecord
		CSB.Initialize.Size(20).Bold.Color(Colors.Red).Append("Notes Updated").PopAll
		ToastMessageShow(CSB, True)
	End If
	
	bolEventInProgress = False

End Sub

'CLOSED EVENTS
'=============

Sub lblReceiptDate_Closed (Cancelled As Boolean, Selection As String)
	
	bolEventInProgress = False
	
	If Cancelled = True Then
		Return
	End If
	
	oldReceiptDate = lblReceiptDate.Text
	lblReceiptDate.Text = Selection

	If oldReceiptDate <> lblReceiptDate.Text Then
		intUpdateType = 1
		strUpdateField = "ReceiptDate"
		strUpdateValue = lblReceiptDate.Text.SubString2(6, 8) & lblReceiptDate.Text.SubString2(3, 5)
		strUpdateValue = strUpdateValue & lblReceiptDate.Text.SubString2(0, 2)
		UpdateReceiptRecord
		CSB.Initialize.Size(20).Bold.Color(Colors.Red).Append("Receipt Date Updated").PopAll
		ToastMessageShow(CSB, True)
	End If

End Sub

Sub lblRetailerName_Closed (Cancelled As Boolean, Selection As String)

	bolEventInProgress = False

	If Cancelled = True Then
		Return
	End If

	oldReceiptRetailerName = lblRetailerName.Text	
	lblRetailerName.Text = Selection
	SelectRetailerID
	
	If oldReceiptRetailerName <> lblRetailerName.Text Then
		intUpdateType = 2
		strUpdateField = "ReceiptRetailerID"
		intUpdateValue = intReceiptRetailerID
		UpdateReceiptRecord
		CSB.Initialize.Size(20).Bold.Color(Colors.Red).Append("Retailer Updated").PopAll
		ToastMessageShow(CSB, True)
	End If

End Sub

Sub lblStoreCharge_Closed (Cancelled As Boolean, Selection As String)
	
	bolEventInProgress = False

	If Cancelled = True Then
		Return
	End If
	
	oldReceiptStoreName = lblStoreCharge.Text
	lblStoreCharge.Text = Selection
	SelectStoreID

	If oldReceiptStoreName <> lblStoreCharge.Text Then
		intUpdateType = 1
		strUpdateField = "ReceiptChargeStoreID"
		strUpdateValue = strStoreID
		UpdateReceiptRecord
		CSB.Initialize.Size(20).Bold.Color(Colors.Red).Append("Store Charge Updated").PopAll
		ToastMessageShow(CSB, True)
	End If
	
End Sub

'TEXT CHANGED EVENTS
'===================

Sub edtAmount_TextChanged (Old As String, New As String)
	
	strAmount = New
	
	If strAmount.Length < 4 Then
		edtAmount.TextColor = Colors.Red
		Return
	End If

	If strAmount.StartsWith("-") _
	 And strAmount.CharAt(1) = "." Then
		edtAmount.TextColor = Colors.Red
		Return
	End If
	
	If strAmount.CharAt(strAmount.Length - 3) <> "." Then
		edtAmount.TextColor = Colors.Red
		Return
	End If

	If strAmount.StartsWith("-") Then
		edtAmount.TextColor = Colors.Green
	Else
		edtAmount.TextColor = Colors.Yellow
	End If
	
End Sub

Sub edtNotes_TextChanged (Old As String, New As String)

	strNotes = New.Trim
	lblNotesLabel.Text = "Notes (" & (int50 - strNotes.Length) & ") :"
	
End Sub